function val = f2(problem,x,y,z)
% This file is part of the OPTPDE problem collection
%                 http://www.optpde.net
% It is provided as is, without any warranty, under the 
%
% Creative Commons Attribution-NonCommercial ShareAlike 4.0 International
%
%         http://creativecommons.org/licenses/by-nc-sa/4.0/
%
% Please give proper credits when using this file by referencing the 
% collection. For this purpose detailed bibliography data is 
% available at the collections website 
%                  
%                 http://www.optpde.net
%
% This file contains data for the benchmark problem 
%                      ccdist2
% from  2022-04-01 



% remember the size of the input and resize it
[m,n,o] = size(x);
x = x(:)';
y = y(:)';
z = z(:)';

% evaluate the function
val = -8*pi^2 * sin(pi*y).^2 .* sin(2*pi*x) .* sin(2*pi*z) + (2*pi^2+2*pi) * sin(2*pi*x) .* cos(2*pi*y) .* sin(2*pi*z);
val = val - max(problem.a(2),min(problem.b(2),sin(pi*y).^2 .* sin(2*pi*x) .* sin(2*pi*z)));

% reshape the output
val = reshape(val,m,n,o);

